-- وظيفة لحساب اوقات الصلاه تلقائيا
-- ماعليك الا تحديد التالي في ما يخص موقعك

-- زاوية الفجر المتبعة في بلدك
FAJR_ANGLE = 18
-- زاوية العشاء المتبعة في بلدك
ISHA_ANGLE = 18.3

-- طريقة حساب العصر 1 = شافعي 2 = حنفي
SF = 1

DESCEND_CORRECTION = 8
-- تعديل اليوم الهجري
local day= 4

-- تعديل الشهر الهجري
month= 1
-- يرجى عدم التغيير  بعد هذه النقطه

require "import"
import "com.androlua.*"
import "android.location.*"
import "android.content.*"
import "android.annotation.TargetApi";
import "android.content.pm.PackageManager";
import "android.os.*";
import "android.util.*";
import "java.io.File"
local file= File("/storage/emulated/0/解说/location3.lua")

function HDate()

-- Import necessary Android libraries
require "import"
import "android.widget.Toast"
import "android.icu.util.Calendar"
import "android.icu.util.ULocale"
import "android.icu.text.SimpleDateFormat"
import "android.os.Build"

-- Function to check if the Android SDK version meets the minimum requirement
function checkAndroidSDK()
    local minSdkVersion = 21 -- Adjust this to your minimal required SDK version
    
    local currentSdkVersion = Build.VERSION.SDK_INT
    
    if currentSdkVersion >= minSdkVersion then
        return true
    else
        print("Your Android version does not meet the minimum requirement.")
        return false
    end
end

-- Function to get the Universal (Gregorian) date with day name in Arabic
function getUniversalDateWithDayName()
    if not checkAndroidSDK() then
        return nil
    end
    
    -- Create a Gregorian calendar instance
    local gregorianCalendar = Calendar.getInstance(ULocale("ar_SA"))

    -- Format the Universal (Gregorian) date with day name in Arabic
    local gregorianSdf = SimpleDateFormat("EEEE dd MMMM yyyy", ULocale("ar_SA"))
    local formattedGregorianDate = gregorianSdf.format(gregorianCalendar.getTime())

    return formattedGregorianDate
end

-- Function to get the Islamic (Hijri) date in Arabic
function getIslamicDate()
    if not checkAndroidSDK() then
        return nil
    end
    
    -- Create an Islamic (Hijri) calendar instance
    local islamicCalendar = Calendar.getInstance(ULocale("ar_SA@calendar=islamic"))

    -- Format the Islamic (Hijri) date
    local islamicSdf = SimpleDateFormat("dd MMMM yyyy", ULocale("ar_SA@calendar=islamic"))
    local formattedIslamicDate = islamicSdf.format(islamicCalendar.getTime())

    return formattedIslamicDate
end

-- Usage example:
local gregorianDateWithDayName = getUniversalDateWithDayName()
local islamicDate = getIslamicDate()

if gregorianDateWithDayName and islamicDate then
    --print(gregorianDateWithDayName .. " الموافق ل" .. islamicDate)
else
    print("Failed to fetch dates.")
end
return gregorianDateWithDayName, islamicDate 
end

function location()

locationManager= service.getBaseContext().getSystemService(this.LOCATION_SERVICE)
bl= locationManager.isLocationEnabled()
local bg= locationManager.isProviderEnabled(locationManager.GPS_PROVIDER)
--local bf= locationManager.isProviderEnabled(locationManager.FUSED_PROVIDER)
local bn= locationManager.isProviderEnabled(locationManager.NETWORK_PROVIDER);

local network= locationManager.NETWORK_PROVIDER
--local fused= locationManager.FUSED_PROVIDER
local gps= locationManager.GPS_PROVIDER

local p2= locationManager.getBestProvider(Criteria(), true)
loc = locationManager.getLastKnownLocation(locationManager.NETWORK_PROVIDER)
locationTrack = Location(loc)
local l= locationTrack.getLongitude()
local a= locationTrack.getLatitude()
local t= locationTrack.getAltitude()

longitude= ("Longitude: " .. locationTrack.getLongitude()) 
Log.v(TAG, longitude) 
latitude= ("Latitude: " .. locationTrack.getLatitude()) 
Log.v(TAG, latitude) 
cityName = null;
gcd= Geocoder(this.getBaseContext(), Locale.getDefault());
addresses= {}
List(addresses)
if l != 0.0
addresses = gcd.getFromLocation(locationTrack.getLatitude(), locationTrack.getLongitude(), 1);
if addresses.size() > 0
 sity= addresses.get(0).getLocality()
print("مواقيت الصلاة لمدينة: ", sity, HDate())
--return sity
end
save= io.open("/storage/emulated/0/解说/location3.lua", "w+")
save:write("r= {"..l..", "..a..", "..t..", '"..sity.."'} \nreturn r")
save:close()

elseif (l == 0.0) and (file.exists() == false)
service.speak("الرجاء تفعيل net و gps")
else
print(" الرجاء تفعيل internet و gps عند الإنتقال إلى مدينة اُخرى, لمرة واحدة, حتى يتم تحديث الإحداثيات الجغرافية, ")
dofile("/storage/emulated/0/解说/location3.lua")
l = r[1]
a= r[2]
t= r[3]
local sity= r[4]
print("مواقيت الصلاة لمدينة: ", r[4], ".",  HDate())

end
return {l, a, t, sity}
end

if service.checkSelfPermission("android.permission.ACCESS_COARSE_LOCATION") and this.checkSelfPermission("android.permission.ACCESS_FINE_LOCATION") != PackageManager. PERMISSION_GRANTED
service.requestPermissions({"android.permission.ACCESS_COARSE_LOCATION"})
 else

local x= location()

--print(x[1])

local LONG= x[1]  
local LAT= x[2] 
local H= x[3] 

function format_time(t)
local h = math.floor(t)
local m = math.floor((t-h)*60 )
local h_prefix  = ""
if h < 10 then
h_prefix = "0"
end
local m_prefix  = ""
if m < 10 then
m_prefix = "0"
end
return h_prefix .. tostring(h) .. ":" .. m_prefix .. tostring(m)
end
function calculate_prayers( )

local Z = tonumber(os.date("%z"))/100
local Y = tonumber(os.date("%Y")) 
local M = tonumber(os.date("%m")) 
local D = tonumber(os.date("%d")) 
local h = tonumber(os.date("%H")) 
local m = tonumber(os.date("%M")) 
local s = tonumber(os.date("%S"))
if M <= 2 then
	M = M + 12
	Y = Y - 1
end
local B = 0
if true then
	 A = math.floor(Y / 100)
	B = 2 + math.floor(A / 4) - A
end
--print ("A " .. A)
--print ("B " .. B)
local JD = 1720994.5 + math.floor(365.25*Y) + math.floor(30.6001* (M + 1)) + B + D +((h*3600 + m*60 + s) / 86400) - (Z / 24)
--print ("JD " .. JD)
local PI = 3.141592653589793
local T = 2 * PI * (JD - 2451545) / 365.25
--print ("T " .. T)
local DELTA = 0.37877 + 23.264 *  math.sin(math.rad(57.297*T - 79.547)) + 
		0.3812 * math.sin(math.rad(2*57.297*T - 82.682)) + 
		0.17132 * math.sin(math.rad(3*57.297*T - 59.722))
--print("delta" .. DELTA)
local U = (JD - 2451545) / 36525
--print("U" .. U)
local L0 = 280.46607 + 36000.7698*U
--print("L0 " .. L0)
local ET1000 = -(1789 + 237*U) * math.sin(math.rad(L0)) -
	     (7146 - 62*U) * math.cos(math.rad(L0)) + 
	     (9934 - 14*U) * math.sin(math.rad(2*L0)) - 
	     (29 + 5*U) * math.cos(math.rad(2*L0)) +
	     (74 + 10*U) * math.sin(math.rad(3*L0)) +
	     (320 - 4*U) * math.cos(math.rad(3*L0)) -
	     212 * math.sin(math.rad(4*L0))
--print("ET1000 " .. ET1000)
local ET = ET1000 / 1000
--print("ET " .. ET)
local TT = 12 + Z - (LONG / 15) - (ET / 60)
--print("TT ".. TT)
local SA_FAJR    = -(FAJR_ANGLE)
--print("sa_fajr ".. SA_FAJR    )
local SA_SUNRISE = -0.8333 - (0.0347 * math.sqrt(H))
--print("sa_sunrise ".. SA_SUNRISE )
local SA_ASR     = math.deg(math.atan(1/(SF + math.tan(math.rad(math.abs(DELTA - LAT))))))
--print("sa_asr ".. SA_ASR     )
local SA_MAGHRIB = SA_SUNRISE
--print("sa_magreb ".. SA_MAGHRIB )
local SA_ISHA    = -(ISHA_ANGLE)
--print("sa_isha ".. SA_ISHA    )
local COS_HA_FAJR = (math.sin(math.rad(SA_FAJR)) - math.sin(math.rad(LAT)) * math.sin(math.rad(DELTA))) / (math.cos(math.rad(LAT)) * math.cos(math.rad(DELTA)))
--print("COS_HA_FAJR  ".. COS_HA_FAJR     )
local HA_FAJR = math.deg(math.acos(COS_HA_FAJR))
--print("HA_FAJR  " .. HA_FAJR )
local FAJR    = TT - HA_FAJR / 15
--print("Fajr " .. FAJR)
local fajr_time = format_time(FAJR)
local COS_HA_SUNRISE = (math.sin(math.rad(SA_SUNRISE)) - math.sin(math.rad(LAT)) * math.sin(math.rad(DELTA))) / (math.cos(math.rad(LAT)) * math.cos(math.rad(DELTA)))
--print("COS_HA_sunrise  ".. COS_HA_SUNRISE)
local HA_SUNRISE = math.deg(math.acos(COS_HA_SUNRISE))
--print("HA_SUNRISE  " .. HA_SUNRISE )
local SUNRISE    = TT - HA_SUNRISE / 15
--print("SUNRISE " .. SUNRISE)
local sunrise_time = format_time(SUNRISE)
local COS_HA_MAGHRIB = (math.sin(math.rad(SA_SUNRISE)) - math.sin(math.rad(LAT)) * math.sin(math.rad(DELTA))) / (math.cos(math.rad(LAT)) * math.cos(math.rad(DELTA)))
--print("COS_HA_MAGHRIB  ".. COS_HA_MAGHRIB)
local HA_MAGHRIB = math.deg(math.acos(COS_HA_MAGHRIB))
--print("HA_MAGHRIB  " .. HA_MAGHRIB )
local MAGHRIB = TT + HA_MAGHRIB / 15
---print("MAGHRIB " .. MAGHRIB)
local maghrib_time = format_time(MAGHRIB)
local COS_HA_ASR = (math.sin(math.rad(SA_ASR)) - math.sin(math.rad(LAT)) * math.sin(math.rad(DELTA))) / (math.cos(math.rad(LAT)) * math.cos(math.rad(DELTA)))
--print("COS_HA_ASR  ".. COS_HA_ASR)
local HA_ASR = math.deg(math.acos(COS_HA_ASR))
--print("HA_ASR  " .. HA_ASR )
local ASR= TT + HA_ASR / 15
--print("ASR " .. ASR)
local asr_time = format_time(ASR)
local COS_HA_ISHA = (math.sin(math.rad(SA_ISHA)) - math.sin(math.rad(LAT)) * math.sin(math.rad(DELTA))) / (math.cos(math.rad(LAT)) * math.cos(math.rad(DELTA)))
--print("COS_HA_ISHA  ".. COS_HA_ISHA)
local HA_ISHA = math.deg(math.acos(COS_HA_ISHA))
--print("HA_ISHA  " .. HA_ISHA )
local ISHA = TT + HA_ISHA / 15
--print("ISHA " .. ISHA)
local isha_time = format_time(ISHA)
local DUHR = TT + DESCEND_CORRECTION / 60
--print("DUHR " .. DUHR)
local duhr_time = format_time(DUHR)

realTime= (h*3600)+(m*60)+s
--print(realTime)
fj1= fajr_time:gsub(":", "")
--print(fj1)
fajrTime=  (tonumber(fj1:match("%d%d", 1, 2))*3600) + (tonumber(fj1:match("%d%d", 3, 4))*60)
--print(fajrTime)

dh1= duhr_time:gsub(":", "")
--print(dh1)
duhrTime=  (tonumber(dh1:match("%d%d", 1, 2))*3600) + (tonumber(dh1:match("%d%d", 3, 4))*60)
--print(duhrTime)

as1= asr_time:gsub(":", "")
--print(as1)
asarTime=  (tonumber(as1:match("%d%d", 1, 2))*3600) + (tonumber(as1:match("%d%d", 3, 4))*60)
--print(asarTime)

mg1= maghrib_time:gsub(":", "")
--print(mg1)
maghribTime=  (tonumber(mg1:match("%d%d", 1, 2))*3600) + (tonumber(mg1:match("%d%d", 3, 4))*60)
--print(maghribTime)

ih1= isha_time:gsub(":", "")
--print(ih1)
ishaTime=  (tonumber(ih1:match("%d%d", 1, 2))*3600) + (tonumber(ih1:match("%d%d", 3, 4))*60)
--print(ishaTime)

prayers = {}

if realTime > fajrTime
fajrT= "مضى عليها".. tointeger((realTime- fajrTime)/3600) .."ساعات و ".. tointeger(((realTime- fajrTime)/60)%60) .."دقيقة"
else 
fajrT= "باقي عليها".. tointeger((fajrTime- realTime)/3600).."ساعات و ".. tointeger(((fajrTime- realTime)/60)%60)  .."دقيقة"
end

prayers[1] = "صَلاةُ الصُبْح :  ".. fajr_time..fajrT

prayers[2] = "شُرُوقُ الشَمْس"..sunrise_time

if realTime > duhrTime
duhrT= "مضى عليها".. tointeger((realTime- duhrTime)/3600) .."ساعات و ".. tointeger(((realTime- duhrTime)/60)%60) .."دقيقة"
else
duhrT= "باقي عليها".. tointeger((duhrTime- realTime)/3600).."ساعات و ".. tointeger(((duhrTime- realTime)/60)%60) .."دقيقة"
end
prayers[3] = "صَلاةُ الظُهْر :  "..duhr_time .. duhrT

if realTime > asarTime
asarT= "مضى عليها".. tointeger((realTime- asarTime)/3600) .."ساعات و ".. tointeger(((realTime- asarTime)/60)%60) .."دقيقة"
else
asarT= "باقي عليها".. tointeger((asarTime- realTime)/3600).."ساعات و ".. tointeger(((asarTime- realTime)/60)%60) .."دقيقة"
end
prayers[4] = "صَلاةُ العَصْر :  "..asr_time.. asarT

if realTime > maghribTime
maghribT= "مضى عليها".. tointeger((realTime- maghribTime)/3600) .."ساعات و ".. tointeger(((realTime- maghribTime)/60)%60) .."دقيقة"
else
maghribT= "باقي عليها".. tointeger((maghribTime- realTime)/3600).."ساعات و ".. tointeger(((maghribTime- realTime)/60)%60) .."دقيقة"
end
prayers[5] = "صَلاةُ المَغْرِب :  "..maghrib_time .. maghribT
if realTime > ishaTime
ishaT= "مضى عليها".. tointeger((realTime- ishaTime)/3600) .."ساعات و ".. tointeger(((realTime- ishaTime)/60)%60) .."دقيقة"
else
ishaT= "باقي عليها".. tointeger((ishaTime- realTime)/3600).."ساعات و ".. tointeger(((ishaTime- realTime)/60)%60) .."دقيقة"
end
prayers[6] = "صَلاةُ العِشاء :  "..isha_time.. ishaT

return prayers

end
result = calculate_prayers()
for i = 1, 6, 1 do
print (result[i])

end
end

function timer()
rt= 1
--rt= 22*3600
rt= realTime
 prayTick= {["الصبح"]= fajrTime-rt, ["الظهر"]= duhrTime-rt, ["العصر"]= asarTime-rt, ["المغرب"]= maghribTime-rt, ["العِشاء"]= ishaTime-rt }
prayTick2= {["الصبح"]= rt - fajrTime, ["الظهر"]= rt - duhrTime, ["العصر"]= rt - asarTime, ["المغرب"]= rt - maghribTime, ["العِشاء"]= rt - ishaTime }
c= {prayTick["الصبح"], prayTick["الظهر"], prayTick["العصر"], prayTick["المغرب"], prayTick["العِشاء"]}
c2= {prayTick2["الصبح"], prayTick2["الظهر"], prayTick2["العصر"], prayTick2["المغرب"], prayTick2["العِشاء"]}
c3= {"الصبح", "الظهر", "العصر", "المغرب", "العِشاء"}
c4= {"العِشاء", "المغرب", "العصر", "الظهر", "الصبح"}

function sort(v1, v5)
if v1 < v5
return true
else
return false
end
end

function get(tbl)
table.sort(tbl, sort)
p1= {}
for i, v ipairs(tbl)
if v > 0
table.insert(p1, v)
end
end

for i, v ipairs(p1)
 rs= tostring(int(v/3600)).."ساعات و"..tostring( int((v/60)%60)).. "دقيقة"
--print(rs)
--print(table.unpack(p1))
break
end
return rs
end

function get2(tbl, tbl2)
table.sort(tbl, sort)
p2= {}
for i, v ipairs(tbl)
if v > 0
table.insert(p2, i)
end

end
table.sort(p2, nil)
for i, v ipairs(p2, tbl2)
rn= tbl2[v]
break
end
return rn
end
a1= get2(c, c3)
a2= get2(c2, c4)

b1= get(c)
b2= get(c2)

a3= table.concat({" مضى على صلاة ", a2, "", b2})
b3= table.concat({"  باقي على صلاة ", a1, b1})

if (fajrTime > rt)
a3= ""
b3= b3
elseif rt > ishaTime 
a3= a3
b3= ""
else
a3= a3
b3=b3
end

print(a3 or nil, b3 or nil)
tm= service.postSpeak(1000, (a3 or "") .. (b3 or ""))
--return true

return tm
end

timer()